diff --git a/src/include/access/brin_xlog.h b/src/include/access/brin_xlog.h
index 1c60dc8adb9..b22137970d3 100644
--- a/src/include/access/brin_xlog.h
+++ b/src/include/access/brin_xlog.h
@@ -47,12 +47,13 @@
  *
  * Backup block 0: metapage
  */
-typedef struct xl_brin_createidx
+typedef struct PG_NO_PADDING xl_brin_createidx
 {
 	BlockNumber pagesPerRange;
 	uint16		version;
+	pg_padding_2(pg_pad);
 } xl_brin_createidx;
-#define SizeOfBrinCreateIdx (offsetof(xl_brin_createidx, version) + sizeof(uint16))
+#define SizeOfBrinCreateIdx (sizeof(xl_brin_createidx))
 
 /*
  * This is what we need to know about a BRIN tuple insert
@@ -60,7 +61,7 @@ typedef struct xl_brin_createidx
  * Backup block 0: main page, block data is the new BrinTuple.
  * Backup block 1: revmap page
  */
-typedef struct xl_brin_insert
+typedef struct PG_NO_PADDING xl_brin_insert
 {
 	BlockNumber heapBlk;
 
@@ -69,9 +70,10 @@ typedef struct xl_brin_insert
 
 	/* offset number in the main page to insert the tuple to. */
 	OffsetNumber offnum;
+	pg_padding_2(pg_pad);
 } xl_brin_insert;
 
-#define SizeOfBrinInsert	(offsetof(xl_brin_insert, offnum) + sizeof(OffsetNumber))
+#define SizeOfBrinInsert	(sizeof(xl_brin_insert))
 
 /*
  * A cross-page update is the same as an insert, but also stores information
@@ -84,27 +86,28 @@ typedef struct xl_brin_insert
  * And in addition:
  * Backup block 2: old page
  */
-typedef struct xl_brin_update
+typedef struct PG_NO_PADDING xl_brin_update
 {
 	/* offset number of old tuple on old page */
 	OffsetNumber oldOffnum;
+	pg_padding_2(pg_pad);
 
 	xl_brin_insert insert;
 } xl_brin_update;
 
-#define SizeOfBrinUpdate	(offsetof(xl_brin_update, insert) + SizeOfBrinInsert)
+#define SizeOfBrinUpdate	(sizeof(xl_brin_update))
 
 /*
  * This is what we need to know about a BRIN tuple samepage update
  *
  * Backup block 0: updated page, with new BrinTuple as block data
  */
-typedef struct xl_brin_samepage_update
+typedef struct PG_NO_PADDING xl_brin_samepage_update
 {
 	OffsetNumber offnum;
 } xl_brin_samepage_update;
 
-#define SizeOfBrinSamepageUpdate		(sizeof(OffsetNumber))
+#define SizeOfBrinSamepageUpdate	(sizeof(xl_brin_samepage_update))
 
 /*
  * This is what we need to know about a revmap extension
@@ -112,7 +115,7 @@ typedef struct xl_brin_samepage_update
  * Backup block 0: metapage
  * Backup block 1: new revmap page
  */
-typedef struct xl_brin_revmap_extend
+typedef struct PG_NO_PADDING xl_brin_revmap_extend
 {
 	/*
 	 * XXX: This is actually redundant - the block number is stored as part of
@@ -121,8 +124,7 @@ typedef struct xl_brin_revmap_extend
 	BlockNumber targetBlk;
 } xl_brin_revmap_extend;
 
-#define SizeOfBrinRevmapExtend	(offsetof(xl_brin_revmap_extend, targetBlk) + \
-								 sizeof(BlockNumber))
+#define SizeOfBrinRevmapExtend	(sizeof(xl_brin_revmap_extend))
 
 /*
  * This is what we need to know about a range de-summarization
@@ -130,17 +132,17 @@ typedef struct xl_brin_revmap_extend
  * Backup block 0: revmap page
  * Backup block 1: regular page
  */
-typedef struct xl_brin_desummarize
+typedef struct PG_NO_PADDING xl_brin_desummarize
 {
 	BlockNumber pagesPerRange;
 	/* page number location to set to invalid */
 	BlockNumber heapBlk;
 	/* offset of item to delete in regular index page */
 	OffsetNumber regOffset;
+	pg_padding_2(pg_pad);
 } xl_brin_desummarize;
 
-#define SizeOfBrinDesummarize	(offsetof(xl_brin_desummarize, regOffset) + \
-								 sizeof(OffsetNumber))
+#define SizeOfBrinDesummarize	(sizeof(xl_brin_desummarize))
 
 
 extern void brin_redo(XLogReaderState *record);
diff --git a/src/include/access/clog.h b/src/include/access/clog.h
index a1cfed5f43c..ee949ca108c 100644
--- a/src/include/access/clog.h
+++ b/src/include/access/clog.h
@@ -29,7 +29,7 @@ typedef int XidStatus;
 #define TRANSACTION_STATUS_ABORTED			0x02
 #define TRANSACTION_STATUS_SUB_COMMITTED	0x03
 
-typedef struct xl_clog_truncate
+typedef struct PG_NO_PADDING xl_clog_truncate
 {
 	int64		pageno;
 	TransactionId oldestXact;
diff --git a/src/include/access/commit_ts.h b/src/include/access/commit_ts.h
index 49ee21cd5d2..92e50b0c806 100644
--- a/src/include/access/commit_ts.h
+++ b/src/include/access/commit_ts.h
@@ -46,14 +46,14 @@ extern int	committssyncfiletag(const FileTag *ftag, char *path);
 #define COMMIT_TS_ZEROPAGE		0x00
 #define COMMIT_TS_TRUNCATE		0x10
 
-typedef struct xl_commit_ts_truncate
+typedef struct PG_NO_PADDING xl_commit_ts_truncate
 {
 	int64		pageno;
 	TransactionId oldestXid;
+	pg_padding_4(pg_pad);
 } xl_commit_ts_truncate;
 
-#define SizeOfCommitTsTruncate	(offsetof(xl_commit_ts_truncate, oldestXid) + \
-								 sizeof(TransactionId))
+#define SizeOfCommitTsTruncate	(sizeof(xl_commit_ts_truncate))
 
 extern void commit_ts_redo(XLogReaderState *record);
 extern void commit_ts_desc(StringInfo buf, XLogReaderState *record);
diff --git a/src/include/access/ginblock.h b/src/include/access/ginblock.h
index 2d75023179a..903c518df39 100644
--- a/src/include/access/ginblock.h
+++ b/src/include/access/ginblock.h
@@ -52,7 +52,7 @@ typedef GinPageOpaqueData *GinPageOpaque;
 #define GIN_METAPAGE_BLKNO	(0)
 #define GIN_ROOT_BLKNO		(1)
 
-typedef struct GinMetaPageData
+typedef struct PG_NO_PADDING GinMetaPageData
 {
 	/*
 	 * Pointers to head and tail of pending list, which consists of GIN_LIST
@@ -80,6 +80,7 @@ typedef struct GinMetaPageData
 	BlockNumber nTotalPages;
 	BlockNumber nEntryPages;
 	BlockNumber nDataPages;
+	pg_padding_4(pg_pad1);
 	int64		nEntries;
 
 	/*
@@ -98,6 +99,7 @@ typedef struct GinMetaPageData
 	 * Reject full-index-scan attempts on such indexes.
 	 */
 	int32		ginVersion;
+	pg_padding_4(pg_pad2);
 } GinMetaPageData;
 
 #define GIN_CURRENT_VERSION		2
@@ -333,7 +335,7 @@ typedef signed char GinNullCategory;
  *
  * Note: This requires 2-byte alignment.
  */
-typedef struct
+typedef struct PG_NO_PADDING
 {
 	ItemPointerData first;		/* first item in this posting list (unpacked) */
 	uint16		nbytes;			/* number of bytes that follow */
diff --git a/src/include/access/ginxlog.h b/src/include/access/ginxlog.h
index 74fdf9b3d7e..7df3b38737c 100644
--- a/src/include/access/ginxlog.h
+++ b/src/include/access/ginxlog.h
@@ -18,7 +18,7 @@
 
 #define XLOG_GIN_CREATE_PTREE  0x10
 
-typedef struct ginxlogCreatePostingTree
+typedef struct PG_NO_PADDING ginxlogCreatePostingTree
 {
 	uint32		size;
 	/* A compressed posting list follows */
@@ -34,7 +34,7 @@ typedef struct ginxlogCreatePostingTree
 
 #define XLOG_GIN_INSERT  0x20
 
-typedef struct
+typedef struct PG_NO_PADDING
 {
 	uint16		flags;			/* GIN_INSERT_ISLEAF and/or GIN_INSERT_ISDATA */
 
@@ -108,7 +108,7 @@ typedef struct
  */
 #define XLOG_GIN_SPLIT	0x30
 
-typedef struct ginxlogSplit
+typedef struct PG_NO_PADDING ginxlogSplit
 {
 	RelFileLocator locator;
 	BlockNumber rrlink;			/* right link, or root's blocknumber if root
@@ -116,6 +116,7 @@ typedef struct ginxlogSplit
 	BlockNumber leftChildBlkno; /* valid on a non-leaf split */
 	BlockNumber rightChildBlkno;
 	uint16		flags;			/* see below */
+	pg_padding_2(pg_pad);
 } ginxlogSplit;
 
 /*
@@ -152,9 +153,10 @@ typedef struct ginxlogVacuumDataLeafPage
  */
 #define XLOG_GIN_DELETE_PAGE	0x50
 
-typedef struct ginxlogDeletePage
+typedef struct PG_NO_PADDING ginxlogDeletePage
 {
 	OffsetNumber parentOffset;
+	pg_padding_2(pg_pad);
 	BlockNumber rightLink;
 	TransactionId deleteXid;	/* last Xid which could see this page in scan */
 } ginxlogDeletePage;
@@ -165,15 +167,17 @@ typedef struct ginxlogDeletePage
  * Backup Blk 0: metapage
  * Backup Blk 1: tail page
  */
-typedef struct ginxlogUpdateMeta
+typedef struct PG_NO_PADDING ginxlogUpdateMeta
 {
 	RelFileLocator locator;
+	pg_padding_4(pg_pad1);
 	GinMetaPageData metadata;
 	BlockNumber prevTail;
 	BlockNumber newRightlink;
 	int32		ntuples;		/* if ntuples > 0 then metadata.tail was
 								 * updated with that many tuples; else new sub
 								 * list was inserted */
+	pg_padding_4(pg_pad2);
 	/* array of inserted tuples follows */
 } ginxlogUpdateMeta;
 
@@ -182,7 +186,7 @@ typedef struct ginxlogUpdateMeta
 /*
  * Backup Blk 0: list page with inserted tuples
  */
-typedef struct ginxlogInsertListPage
+typedef struct PG_NO_PADDING ginxlogInsertListPage
 {
 	BlockNumber rightlink;
 	int32		ntuples;
@@ -203,10 +207,11 @@ typedef struct ginxlogInsertListPage
  * metapage.)
  */
 #define GIN_NDELETE_AT_ONCE Min(16, XLR_MAX_BLOCK_ID - 1)
-typedef struct ginxlogDeleteListPages
+typedef struct PG_NO_PADDING ginxlogDeleteListPages
 {
 	GinMetaPageData metadata;
 	int32		ndeleted;
+	pg_padding_4(pg_pad);
 } ginxlogDeleteListPages;
 
 extern void gin_redo(XLogReaderState *record);
diff --git a/src/include/access/gistxlog.h b/src/include/access/gistxlog.h
index d3d1c6549be..f19d4e8dfe6 100644
--- a/src/include/access/gistxlog.h
+++ b/src/include/access/gistxlog.h
@@ -33,7 +33,7 @@
  * Backup Blk 1: If this operation completes a page split, by inserting a
  *				 downlink for the split page, the left half of the split
  */
-typedef struct gistxlogPageUpdate
+typedef struct PG_NO_PADDING gistxlogPageUpdate
 {
 	/* number of deleted offsets */
 	uint16		ntodelete;
@@ -47,12 +47,13 @@ typedef struct gistxlogPageUpdate
 /*
  * Backup Blk 0: Leaf page, whose index tuples are deleted.
  */
-typedef struct gistxlogDelete
+typedef struct PG_NO_PADDING gistxlogDelete
 {
 	TransactionId snapshotConflictHorizon;
 	uint16		ntodelete;		/* number of deleted offsets */
 	bool		isCatalogRel;	/* to handle recovery conflict during logical
 								 * decoding on standby */
+	pg_padding_1(pg_pad);
 
 	/* TODELETE OFFSET NUMBERS */
 	OffsetNumber offsets[FLEXIBLE_ARRAY_MEMBER];
@@ -65,14 +66,18 @@ typedef struct gistxlogDelete
  *				 downlink for the split page, the left half of the split
  * Backup Blk 1 - npage: split pages (1 is the original page)
  */
-typedef struct gistxlogPageSplit
+typedef struct PG_NO_PADDING gistxlogPageSplit
 {
 	BlockNumber origrlink;		/* rightlink of the page before split */
+	pg_padding_4(pg_pad1);
 	GistNSN		orignsn;		/* NSN of the page before split */
 	bool		origleaf;		/* was split page a leaf page? */
+	pg_padding_1(pg_pad2);
 
 	uint16		npage;			/* # of pages in the split */
 	bool		markfollowright;	/* set F_FOLLOW_RIGHT flags */
+	pg_padding_1(pg_pad3);
+	pg_padding_2(pg_pad4);
 
 	/*
 	 * follow: 1. gistxlogPage and array of IndexTupleData per page
@@ -83,29 +88,34 @@ typedef struct gistxlogPageSplit
  * Backup Blk 0: page that was deleted.
  * Backup Blk 1: parent page, containing the downlink to the deleted page.
  */
-typedef struct gistxlogPageDelete
+typedef struct PG_NO_PADDING gistxlogPageDelete
 {
 	FullTransactionId deleteXid;	/* last Xid which could see page in scan */
 	OffsetNumber downlinkOffset;	/* Offset of downlink referencing this
 									 * page */
+	pg_padding_2(pg_pad1);
+	pg_padding_4(pg_pad2);
 } gistxlogPageDelete;
 
-#define SizeOfGistxlogPageDelete	(offsetof(gistxlogPageDelete, downlinkOffset) + sizeof(OffsetNumber))
+#define SizeOfGistxlogPageDelete	(sizeof(gistxlogPageDelete))
 
 
 /*
  * This is what we need to know about page reuse, for hot standby.
  */
-typedef struct gistxlogPageReuse
+typedef struct PG_NO_PADDING gistxlogPageReuse
 {
 	RelFileLocator locator;
 	BlockNumber block;
 	FullTransactionId snapshotConflictHorizon;
 	bool		isCatalogRel;	/* to handle recovery conflict during logical
 								 * decoding on standby */
+	pg_padding_1(pg_pad1);
+	pg_padding_2(pg_pad2);
+	pg_padding_4(pg_pad4);
 } gistxlogPageReuse;
 
-#define SizeOfGistxlogPageReuse	(offsetof(gistxlogPageReuse, isCatalogRel) + sizeof(bool))
+#define SizeOfGistxlogPageReuse	(sizeof(gistxlogPageReuse))
 
 extern void gist_redo(XLogReaderState *record);
 extern void gist_desc(StringInfo buf, XLogReaderState *record);
diff --git a/src/include/access/hash_xlog.h b/src/include/access/hash_xlog.h
index 149aed69dc5..bb6b9d0fe11 100644
--- a/src/include/access/hash_xlog.h
+++ b/src/include/access/hash_xlog.h
@@ -59,12 +59,12 @@
  * Backup Blk 0: original page (data contains the inserted tuple)
  * Backup Blk 1: metapage (HashMetaPageData)
  */
-typedef struct xl_hash_insert
+typedef struct PG_NO_PADDING xl_hash_insert
 {
 	OffsetNumber offnum;
 } xl_hash_insert;
 
-#define SizeOfHashInsert	(offsetof(xl_hash_insert, offnum) + sizeof(OffsetNumber))
+#define SizeOfHashInsert	(sizeof(xl_hash_insert))
 
 /*
  * This is what we need to know about addition of overflow page.
@@ -77,14 +77,14 @@ typedef struct xl_hash_insert
  * Backup Blk 3: new bitmap page
  * Backup Blk 4: metapage
  */
-typedef struct xl_hash_add_ovfl_page
+typedef struct PG_NO_PADDING xl_hash_add_ovfl_page
 {
 	uint16		bmsize;
 	bool		bmpage_found;
+	pg_padding_1(pg_pad);
 } xl_hash_add_ovfl_page;
 
-#define SizeOfHashAddOvflPage	\
-	(offsetof(xl_hash_add_ovfl_page, bmpage_found) + sizeof(bool))
+#define SizeOfHashAddOvflPage	(sizeof(xl_hash_add_ovfl_page))
 
 /*
  * This is what we need to know about allocating a page for split.
@@ -95,16 +95,17 @@ typedef struct xl_hash_add_ovfl_page
  * Backup Blk 1: page for new bucket
  * Backup Blk 2: metapage
  */
-typedef struct xl_hash_split_allocate_page
+typedef struct PG_NO_PADDING xl_hash_split_allocate_page
 {
 	uint32		new_bucket;
 	uint16		old_bucket_flag;
 	uint16		new_bucket_flag;
 	uint8		flags;
+	pg_padding_1(pg_pad1);
+	pg_padding_2(pg_pad2);
 } xl_hash_split_allocate_page;
 
-#define SizeOfHashSplitAllocPage	\
-	(offsetof(xl_hash_split_allocate_page, flags) + sizeof(uint8))
+#define SizeOfHashSplitAllocPage	(sizeof(xl_hash_split_allocate_page))
 
 /*
  * This is what we need to know about completing the split operation.
@@ -114,14 +115,13 @@ typedef struct xl_hash_split_allocate_page
  * Backup Blk 0: page for old bucket
  * Backup Blk 1: page for new bucket
  */
-typedef struct xl_hash_split_complete
+typedef struct PG_NO_PADDING xl_hash_split_complete
 {
 	uint16		old_bucket_flag;
 	uint16		new_bucket_flag;
 } xl_hash_split_complete;
 
-#define SizeOfHashSplitComplete \
-	(offsetof(xl_hash_split_complete, new_bucket_flag) + sizeof(uint16))
+#define SizeOfHashSplitComplete	(sizeof(xl_hash_split_complete))
 
 /*
  * This is what we need to know about move page contents required during
@@ -133,16 +133,16 @@ typedef struct xl_hash_split_complete
  * Backup Blk 1: page containing moved tuples
  * Backup Blk 2: page from which tuples will be removed
  */
-typedef struct xl_hash_move_page_contents
+typedef struct PG_NO_PADDING xl_hash_move_page_contents
 {
 	uint16		ntups;
 	bool		is_prim_bucket_same_wrt;	/* true if the page to which
 											 * tuples are moved is same as
 											 * primary bucket page */
+	pg_padding_1(pg_pad);
 } xl_hash_move_page_contents;
 
-#define SizeOfHashMovePageContents	\
-	(offsetof(xl_hash_move_page_contents, is_prim_bucket_same_wrt) + sizeof(bool))
+#define SizeOfHashMovePageContents	(sizeof(xl_hash_move_page_contents))
 
 /*
  * This is what we need to know about the squeeze page operation.
@@ -157,7 +157,7 @@ typedef struct xl_hash_move_page_contents
  * Backup Blk 5: bitmap page containing info of freed overflow page
  * Backup Blk 6: meta page
  */
-typedef struct xl_hash_squeeze_page
+typedef struct PG_NO_PADDING xl_hash_squeeze_page
 {
 	BlockNumber prevblkno;
 	BlockNumber nextblkno;
@@ -171,8 +171,7 @@ typedef struct xl_hash_squeeze_page
 											 * page */
 } xl_hash_squeeze_page;
 
-#define SizeOfHashSqueezePage	\
-	(offsetof(xl_hash_squeeze_page, is_prev_bucket_same_wrt) + sizeof(bool))
+#define SizeOfHashSqueezePage	(sizeof(xl_hash_squeeze_page))
 
 /*
  * This is what we need to know about the deletion of index tuples from a page.
@@ -182,7 +181,7 @@ typedef struct xl_hash_squeeze_page
  * Backup Blk 0: primary bucket page
  * Backup Blk 1: page from which tuples are deleted
  */
-typedef struct xl_hash_delete
+typedef struct PG_NO_PADDING xl_hash_delete
 {
 	bool		clear_dead_marking; /* true if this operation clears
 									 * LH_PAGE_HAS_DEAD_TUPLES flag */
@@ -190,7 +189,7 @@ typedef struct xl_hash_delete
 										 * primary bucket page */
 } xl_hash_delete;
 
-#define SizeOfHashDelete	(offsetof(xl_hash_delete, is_primary_bucket_page) + sizeof(bool))
+#define SizeOfHashDelete	(sizeof(xl_hash_delete))
 
 /*
  * This is what we need for metapage update operation.
@@ -199,13 +198,12 @@ typedef struct xl_hash_delete
  *
  * Backup Blk 0: meta page
  */
-typedef struct xl_hash_update_meta_page
+typedef struct PG_NO_PADDING xl_hash_update_meta_page
 {
 	double		ntuples;
 } xl_hash_update_meta_page;
 
-#define SizeOfHashUpdateMetaPage	\
-	(offsetof(xl_hash_update_meta_page, ntuples) + sizeof(double))
+#define SizeOfHashUpdateMetaPage	(sizeof(xl_hash_update_meta_page))
 
 /*
  * This is what we need to initialize metapage.
@@ -214,15 +212,15 @@ typedef struct xl_hash_update_meta_page
  *
  * Backup Blk 0: meta page
  */
-typedef struct xl_hash_init_meta_page
+typedef struct PG_NO_PADDING xl_hash_init_meta_page
 {
 	double		num_tuples;
 	RegProcedure procid;
 	uint16		ffactor;
+	pg_padding_2(pg_pad);
 } xl_hash_init_meta_page;
 
-#define SizeOfHashInitMetaPage		\
-	(offsetof(xl_hash_init_meta_page, ffactor) + sizeof(uint16))
+#define SizeOfHashInitMetaPage	(sizeof(xl_hash_init_meta_page))
 
 /*
  * This is what we need to initialize bitmap page.
@@ -232,13 +230,12 @@ typedef struct xl_hash_init_meta_page
  * Backup Blk 0: bitmap page
  * Backup Blk 1: meta page
  */
-typedef struct xl_hash_init_bitmap_page
+typedef struct PG_NO_PADDING xl_hash_init_bitmap_page
 {
 	uint16		bmsize;
 } xl_hash_init_bitmap_page;
 
-#define SizeOfHashInitBitmapPage	\
-	(offsetof(xl_hash_init_bitmap_page, bmsize) + sizeof(uint16))
+#define SizeOfHashInitBitmapPage	(sizeof(xl_hash_init_bitmap_page))
 
 /*
  * This is what we need for index tuple deletion and to
@@ -249,12 +246,13 @@ typedef struct xl_hash_init_bitmap_page
  * Backup Blk 0: primary bucket page
  * Backup Blk 1: meta page
  */
-typedef struct xl_hash_vacuum_one_page
+typedef struct PG_NO_PADDING xl_hash_vacuum_one_page
 {
 	TransactionId snapshotConflictHorizon;
 	uint16		ntuples;
 	bool		isCatalogRel;	/* to handle recovery conflict during logical
 								 * decoding on standby */
+	pg_padding_1(pg_pad);
 
 	/* TARGET OFFSET NUMBERS */
 	OffsetNumber offsets[FLEXIBLE_ARRAY_MEMBER];
diff --git a/src/include/access/heapam_xlog.h b/src/include/access/heapam_xlog.h
index ce3566ba949..74a3803ad14 100644
--- a/src/include/access/heapam_xlog.h
+++ b/src/include/access/heapam_xlog.h
@@ -110,7 +110,7 @@
 	(XLH_DELETE_CONTAINS_OLD_TUPLE | XLH_DELETE_CONTAINS_OLD_KEY)
 
 /* This is what we need to know about delete */
-typedef struct xl_heap_delete
+typedef struct PG_NO_PADDING xl_heap_delete
 {
 	TransactionId xmax;			/* xmax of the deleted tuple */
 	OffsetNumber offnum;		/* deleted tuple's offset */
@@ -118,7 +118,7 @@ typedef struct xl_heap_delete
 	uint8		flags;
 } xl_heap_delete;
 
-#define SizeOfHeapDelete	(offsetof(xl_heap_delete, flags) + sizeof(uint8))
+#define SizeOfHeapDelete	sizeof(xl_heap_delete)
 
 /*
  * xl_heap_truncate flag values, 8 bits are available.
@@ -131,11 +131,13 @@ typedef struct xl_heap_delete
  * sequence relids that need to be restarted, if any.
  * All rels are always within the same database, so we just list dbid once.
  */
-typedef struct xl_heap_truncate
+typedef struct PG_NO_PADDING xl_heap_truncate
 {
 	Oid			dbId;
 	uint32		nrelids;
 	uint8		flags;
+	pg_padding_1(pg_pad1);
+	pg_padding_2(pg_pad2);
 	Oid			relids[FLEXIBLE_ARRAY_MEMBER];
 } xl_heap_truncate;
 
@@ -147,25 +149,27 @@ typedef struct xl_heap_truncate
  * fields that are available elsewhere in the WAL record, or perhaps just
  * plain needn't be reconstructed.  These are the fields we must store.
  */
-typedef struct xl_heap_header
+typedef struct PG_NO_PADDING xl_heap_header
 {
 	uint16		t_infomask2;
 	uint16		t_infomask;
 	uint8		t_hoff;
+	pg_padding_1(pg_pad);
 } xl_heap_header;
 
-#define SizeOfHeapHeader	(offsetof(xl_heap_header, t_hoff) + sizeof(uint8))
+#define SizeOfHeapHeader	sizeof(xl_heap_header)
 
 /* This is what we need to know about insert */
-typedef struct xl_heap_insert
+typedef struct PG_NO_PADDING xl_heap_insert
 {
 	OffsetNumber offnum;		/* inserted tuple's offset */
 	uint8		flags;
+	pg_padding_1(pg_pad);
 
 	/* xl_heap_header & TUPLE DATA in backup block 0 */
 } xl_heap_insert;
 
-#define SizeOfHeapInsert	(offsetof(xl_heap_insert, flags) + sizeof(uint8))
+#define SizeOfHeapInsert	sizeof(xl_heap_insert)
 
 /*
  * This is what we need to know about a multi-insert.
@@ -178,25 +182,27 @@ typedef struct xl_heap_insert
  * followed by the tuple data for each tuple. There is padding to align
  * each xl_multi_insert_tuple struct.
  */
-typedef struct xl_heap_multi_insert
+typedef struct PG_NO_PADDING xl_heap_multi_insert
 {
 	uint8		flags;
+	pg_padding_1(pg_pad);
 	uint16		ntuples;
 	OffsetNumber offsets[FLEXIBLE_ARRAY_MEMBER];
 } xl_heap_multi_insert;
 
 #define SizeOfHeapMultiInsert	offsetof(xl_heap_multi_insert, offsets)
 
-typedef struct xl_multi_insert_tuple
+typedef struct PG_NO_PADDING xl_multi_insert_tuple
 {
 	uint16		datalen;		/* size of tuple data that follows */
 	uint16		t_infomask2;
 	uint16		t_infomask;
 	uint8		t_hoff;
+	pg_padding_1(pg_pad);
 	/* TUPLE DATA FOLLOWS AT END OF STRUCT */
 } xl_multi_insert_tuple;
 
-#define SizeOfMultiInsertTuple	(offsetof(xl_multi_insert_tuple, t_hoff) + sizeof(uint8))
+#define SizeOfMultiInsertTuple	sizeof(xl_multi_insert_tuple)
 
 /*
  * This is what we need to know about update|hot_update
@@ -215,7 +221,7 @@ typedef struct xl_multi_insert_tuple
  *
  * Backup blk 1: old page, if different. (no data, just a reference to the blk)
  */
-typedef struct xl_heap_update
+typedef struct PG_NO_PADDING xl_heap_update
 {
 	TransactionId old_xmax;		/* xmax of the old tuple */
 	OffsetNumber old_offnum;	/* old tuple's offset */
@@ -223,6 +229,7 @@ typedef struct xl_heap_update
 	uint8		flags;
 	TransactionId new_xmax;		/* xmax of the new tuple */
 	OffsetNumber new_offnum;	/* new tuple's offset */
+	pg_padding_2(pg_pad);
 
 	/*
 	 * If XLH_UPDATE_CONTAINS_OLD_TUPLE or XLH_UPDATE_CONTAINS_OLD_KEY flags
@@ -230,7 +237,7 @@ typedef struct xl_heap_update
 	 */
 } xl_heap_update;
 
-#define SizeOfHeapUpdate	(offsetof(xl_heap_update, new_offnum) + sizeof(OffsetNumber))
+#define SizeOfHeapUpdate	sizeof(xl_heap_update)
 
 /*
  * These structures and flags encode VACUUM pruning and freezing and on-access
@@ -282,7 +289,7 @@ typedef struct xl_heap_update
  * other fields require only 2-byte alignment.  This is also the reason that
  * 'frz_offsets' is stored separately from the xlhp_freeze_plan structs.
  */
-typedef struct xl_heap_prune
+typedef struct PG_NO_PADDING xl_heap_prune
 {
 	uint16		flags;
 
@@ -292,7 +299,7 @@ typedef struct xl_heap_prune
 	 */
 } xl_heap_prune;
 
-#define SizeOfHeapPrune (offsetof(xl_heap_prune, flags) + sizeof(uint16))
+#define SizeOfHeapPrune sizeof(xl_heap_prune)
 
 /* to handle recovery conflict during logical decoding on standby */
 #define		XLHP_IS_CATALOG_REL			(1 << 1)
@@ -347,12 +354,13 @@ typedef struct xl_heap_prune
 #define		XLH_FREEZE_XVAC		0x02
 #define		XLH_INVALID_XVAC	0x04
 
-typedef struct xlhp_freeze_plan
+typedef struct PG_NO_PADDING xlhp_freeze_plan
 {
 	TransactionId xmax;
 	uint16		t_infomask2;
 	uint16		t_infomask;
 	uint8		frzflags;
+	pg_padding_1(pg_pad);
 
 	/* Length of individual page offset numbers array for this plan */
 	uint16		ntuples;
@@ -370,9 +378,10 @@ typedef struct xlhp_freeze_plan
  * (As of PostgreSQL 17, XLOG_HEAP2_PRUNE_VACUUM_SCAN records replace the
  * separate XLOG_HEAP2_FREEZE_PAGE records.)
  */
-typedef struct xlhp_freeze_plans
+typedef struct PG_NO_PADDING xlhp_freeze_plans
 {
 	uint16		nplans;
+	pg_padding_2(pg_pad);
 	xlhp_freeze_plan plans[FLEXIBLE_ARRAY_MEMBER];
 } xlhp_freeze_plans;
 
@@ -383,7 +392,7 @@ typedef struct xlhp_freeze_plans
  * set.  Note that in the XLHP_HAS_REDIRECTIONS variant, there are actually 2
  * * length number of OffsetNumbers in the data.
  */
-typedef struct xlhp_prune_items
+typedef struct PG_NO_PADDING xlhp_prune_items
 {
 	uint16		ntargets;
 	OffsetNumber data[FLEXIBLE_ARRAY_MEMBER];
@@ -401,7 +410,7 @@ typedef struct xlhp_prune_items
 #define XLH_LOCK_ALL_FROZEN_CLEARED		0x01
 
 /* This is what we need to know about lock */
-typedef struct xl_heap_lock
+typedef struct PG_NO_PADDING xl_heap_lock
 {
 	TransactionId xmax;			/* might be a MultiXactId */
 	OffsetNumber offnum;		/* locked tuple's offset on page */
@@ -409,10 +418,10 @@ typedef struct xl_heap_lock
 	uint8		flags;			/* XLH_LOCK_* flag bits */
 } xl_heap_lock;
 
-#define SizeOfHeapLock	(offsetof(xl_heap_lock, flags) + sizeof(uint8))
+#define SizeOfHeapLock	sizeof(xl_heap_lock)
 
 /* This is what we need to know about locking an updated version of a row */
-typedef struct xl_heap_lock_updated
+typedef struct PG_NO_PADDING xl_heap_lock_updated
 {
 	TransactionId xmax;
 	OffsetNumber offnum;
@@ -420,23 +429,26 @@ typedef struct xl_heap_lock_updated
 	uint8		flags;
 } xl_heap_lock_updated;
 
-#define SizeOfHeapLockUpdated	(offsetof(xl_heap_lock_updated, flags) + sizeof(uint8))
+#define SizeOfHeapLockUpdated	sizeof(xl_heap_lock_updated)
 
 /* This is what we need to know about confirmation of speculative insertion */
-typedef struct xl_heap_confirm
+typedef struct PG_NO_PADDING xl_heap_confirm
 {
 	OffsetNumber offnum;		/* confirmed tuple's offset on page */
 } xl_heap_confirm;
 
-#define SizeOfHeapConfirm	(offsetof(xl_heap_confirm, offnum) + sizeof(OffsetNumber))
+#define SizeOfHeapConfirm	sizeof(xl_heap_confirm)
 
 /* This is what we need to know about in-place update */
-typedef struct xl_heap_inplace
+typedef struct PG_NO_PADDING xl_heap_inplace
 {
 	OffsetNumber offnum;		/* updated tuple's offset on page */
+	pg_padding_2(pg_pad1);
 	Oid			dbId;			/* MyDatabaseId */
 	Oid			tsId;			/* MyDatabaseTableSpace */
 	bool		relcacheInitFileInval;	/* invalidate relcache init files */
+	pg_padding_1(pg_pad2);
+	pg_padding_2(pg_pad3);
 	int			nmsgs;			/* number of shared inval msgs */
 	SharedInvalidationMessage msgs[FLEXIBLE_ARRAY_MEMBER];
 } xl_heap_inplace;
@@ -449,15 +461,17 @@ typedef struct xl_heap_inplace
  * Backup blk 0: visibility map buffer
  * Backup blk 1: heap buffer
  */
-typedef struct xl_heap_visible
+typedef struct PG_NO_PADDING xl_heap_visible
 {
 	TransactionId snapshotConflictHorizon;
 	uint8		flags;
+	pg_padding_1(pg_pad1);
+	pg_padding_2(pg_pad2);
 } xl_heap_visible;
 
-#define SizeOfHeapVisible (offsetof(xl_heap_visible, flags) + sizeof(uint8))
+#define SizeOfHeapVisible sizeof(xl_heap_visible)
 
-typedef struct xl_heap_new_cid
+typedef struct PG_NO_PADDING xl_heap_new_cid
 {
 	/*
 	 * store toplevel xid so we don't have to merge cids from different
@@ -473,18 +487,21 @@ typedef struct xl_heap_new_cid
 	 */
 	RelFileLocator target_locator;
 	ItemPointerData target_tid;
+	pg_padding_2(pg_pad);
 } xl_heap_new_cid;
 
-#define SizeOfHeapNewCid (offsetof(xl_heap_new_cid, target_tid) + sizeof(ItemPointerData))
+#define SizeOfHeapNewCid sizeof(xl_heap_new_cid)
 
 /* logical rewrite xlog record header */
-typedef struct xl_heap_rewrite_mapping
+typedef struct PG_NO_PADDING xl_heap_rewrite_mapping
 {
 	TransactionId mapped_xid;	/* xid that might need to see the row */
 	Oid			mapped_db;		/* DbOid or InvalidOid for shared rels */
 	Oid			mapped_rel;		/* Oid of the mapped relation */
+	pg_padding_4(pg_pad1);
 	off_t		offset;			/* How far have we written so far */
 	uint32		num_mappings;	/* Number of in-memory mappings */
+	pg_padding_4(pg_pad2);
 	XLogRecPtr	start_lsn;		/* Insert LSN at begin of rewrite */
 } xl_heap_rewrite_mapping;
 
diff --git a/src/include/access/multixact.h b/src/include/access/multixact.h
index 2ae8b571dcc..3fe4501d27f 100644
--- a/src/include/access/multixact.h
+++ b/src/include/access/multixact.h
@@ -69,17 +69,19 @@ typedef struct MultiXactMember
 #define XLOG_MULTIXACT_CREATE_ID		0x20
 #define XLOG_MULTIXACT_TRUNCATE_ID		0x30
 
-typedef struct xl_multixact_create
+typedef struct PG_NO_PADDING xl_multixact_create
 {
 	MultiXactId mid;			/* new MultiXact's ID */
+	pg_padding_4(pg_pad1);
 	MultiXactOffset moff;		/* its starting offset in members file */
 	int32		nmembers;		/* number of member XIDs */
+	pg_padding_4(pg_pad2);
 	MultiXactMember members[FLEXIBLE_ARRAY_MEMBER];
 } xl_multixact_create;
 
 #define SizeOfMultiXactCreate (offsetof(xl_multixact_create, members))
 
-typedef struct xl_multixact_truncate
+typedef struct PG_NO_PADDING xl_multixact_truncate
 {
 	Oid			oldestMultiDB;
 
